/***************************************************************************/
/*
 * recv.c --
 *
 * TCP/IP PVM-latency test receiver.
 *
 * $Id: recv.c,v 1.1 95/02/24 17:34:24 tfisher Exp Locker: tfisher $
 *
 * Copyright (c) 1995 by the University of Southern California.
 * Permission to use, copy, modify, and distribute this software and its
 * documentation in source and binary forms for non-commercial purposes
 * and without fee is hereby granted, provided that the above copyright
 * notice appear in all copies and that both the copyright notice and
 * this permission notice appear in supporting documentation, and that
 * any documentation, advertising materials, and other materials related
 * to such distribution and use acknowledge that the software was
 * developed by the University of Southern California, Information
 * Sciences Institute.  The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * All rights reserved.
 *
 * THE UNIVERSITY OF SOUTHERN CALIFORNIA makes no representations about
 * the suitability of this software for any purpose.  This software
 * is provided "as is" and without any express or implied warranties,
 * including, without limitation, the implied warranties of merchant-
 * ibility and fitness for a particular purpose.
 *
 * For more information: 
 * Tom Fisher (tfisher@isi.edu) or Hong Xu (xu@isi.edu)
 */
/***************************************************************************/

#include <stdio.h>
#include "pvm3.h"

#define MSG_BEGIN	3
#define MSG_DATA	4


int
main(int argc, char *argv[])
{
	int i;
	int local;		/* local task id */
	int parent;		/* parent task id */
	int size;		/* amount of data per iteration */
	int nloops;		/* number of receive iterations */
	char *data;		/* data buffer */

	/* Check for and get command line args. */
	if (parse_args(argc, argv, NULL, &size, &nloops) < 0)
		exit (1);

	/* Enroll in pvm. */
	local = pvm_mytid();
	parent = pvm_parent();

	/* Initialize. */
	data = (char *)alloc(size);
	pvm_initsend(PvmDataRaw);

	/* Echo data. */
	pvm_recv(parent, MSG_BEGIN);
	for (i=0; i < nloops; i++) {
		pvm_recv(parent, MSG_DATA);
		pvm_send(parent, MSG_DATA);
	}

	/* Program finished. Exit PVM before stopping */
	pvm_exit();
	exit (0);
}
