#include <signal.h>
#include <sys/wait.h>

/* Home of executables. */
#define HOME "/nfs/atom/tfisher/src/atp-bandwidth"

/* Log file names. */
#define SENDLOG "sendLog-30x32-07.15.95"
#define RECVLOG "recvLog-30x32-07.15.95"

/* Session definitions. */
struct execution {
        int    dataLength;
        int    nExecutions;
        int    nIterations;
} executions[] = {
#ifdef XXX
        { 4,         10000,        100 },
        { 8,         10000,        100 },
        { 16,        10000,        100 },
        { 32,        10000,        100 },
        { 64,        10000,        100 },
        { 128,       10000,        100 },
        { 256,       10000,        100 },
        { 512,       10000,        100 },
        { 1024,      10000,        100 },
        { 2048,      10000,        100 },
        { 4096,      10000,        100 },
        { 5120,      10000,        100 },
        { 6144,      10000,        100 },
        { 7168,      10000,        100 },
#endif XXX
        { 8192,      10000,        100 },
        { 16384,     5000,         50 },
        { 32768,     5000,         50 },
        { 65536,     5000,         50 },
        { 131072,    5000,         50 },
        { 262144,    5000,         50 },
        { 524288,    5000,         50 },
        { 1048567,   5000,         50 },
        { 2097152,   5000,         50 },
        { 3145728,   5000,         50 },
        { 4194295,   5000,         50 },
};


int
main()
{
	int i, j;
	int pid;
	int sendpid;
	int recvpid;
	int limit;
	int tries;
	int status=0;
	char command[128];
	struct execution *p;

	p = executions;
	limit = sizeof(executions) / sizeof(struct execution);

	for (i=0; i < limit; i++, p++) {
		for (j=0; j < p->nIterations; j++) {

			/* Start the receiver first. */
			if ((recvpid = fork()) == 0) {
			    sprintf(command, 
			        "nice -20 %s/recv keg %d %d >> %s 2>&1",
			        HOME, p->dataLength, p->nExecutions, RECVLOG);
			    system(command);
			    exit(0);
			}
	
			/* Start the sender now. */
			if ((sendpid = fork()) == 0) {
			    sprintf(command, 
			      "(rsh keg nice -20 %s/send mug %d %d) >> %s 2>&1",
			      HOME, p->dataLength, p->nExecutions, SENDLOG);
			    system(command);
			    exit(0);
			}
	
			/* Temp output. */
			printf(">>> [%d] recv keg %d %d\n", 
			    recvpid, p->dataLength, p->nExecutions);
			printf(">>> [%d] send mug %d %d\n", 
			    sendpid, p->dataLength, p->nExecutions);
	
#define MAX_TRIES 60
			/* 
			 * Wait for procs to stop, otherwise kill them.
			 */
			while ((sendpid || recvpid)) {
				for (tries=0; tries < MAX_TRIES; tries++) {
					pid = wait3(&status, 
					    WNOHANG|WUNTRACED, 0);
					if (pid)
					    break;
					sleep(20);
				}

				if (tries == MAX_TRIES) {
					printf("Timed-out!\n");
					if (sendpid)
					    system("cleanup send");
					if (recvpid)
					    system("cleanup recv");
					sleep(2);
					break;
				}

				if (pid < 0)
					break;
				if (pid == 0) {
					printf("pid=0, status=0x%x.\n", 
					    status);
					continue;
				}
				if (pid == sendpid || 
				    pid == recvpid) {
					if (status) {
					    kill(pid, 9);
					    printf("Killed pid=%d.\n", pid);
					}
					if (pid == sendpid) {
						printf("Done [%d]\n", pid);
						sendpid = 0;
					} else if (pid == recvpid) {
						printf("Done [%d]\n", pid);
						recvpid = 0;
					}
				}
			}
		}
		printf("\n");
	}
	exit(0);
}
