/*
 * recv.c --
 *
 * Myrinet ATP-test receiver.
 *
 * $Id: recv.c,v 1.4 95/07/24 16:25:34 tfisher Exp Locker: tfisher $
 */

#include <stdio.h>
#include "atp.h"

int
main(int argc, char *argv[])
{
	int unit=0;		/* myrinet board to use */
	int interface=1;	/* myrinet interface to use */
	int size;		/* amount of data per iteration */
	int sessID;		/* unique session descripter */
	char *buff;		/* data buffer */
	char *host;		/* destination host */

	/* Check for and get command line args. */
	if (parse_args(argc, argv, &host, &size) < 0)
		exit (1);

	/* Initialize. */
	buff = (char *)alloc(size);

	/* Open a connection. */
	sessID = atp_open(unit, interface, host);

	/* Round-trip handshake. */
	atp_receive(sessID, buff, size);
	atp_send(sessID, buff, size);

	/* Shutdown connection. */
	atp_close(sessID);
	exit(0);
}
